#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <time.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <gtk/gtk.h>
#include <pthread.h>
#include <sys/signal.h>

#define versionString 	"2.0.0.spinlite.0"

typedef struct _channel
{
	char *name;
	int id;
} Channel;

extern char **environ;

GList *Channels;
Channel *current;
Channel *cnone;
GtkWidget *lalbum, *lartist, *lsong, *lmenu, *lchannel;
pid_t trpid;
pthread_cond_t cond = PTHREAD_COND_INITIALIZER;
pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;

int my_system(char *command) 
{
	int pid, status;
	if (command == 0) return 1;
	pid = fork();
	if (pid == -1) return -1;
	if (pid == 0) 
	{
		char *argv[4];
		argv[0] = "sh";
		argv[1] = "-c";
		argv[2] = command;
		argv[3] = 0;
		execve("/bin/sh", argv, environ);
		exit(127);
	}
	trpid = pid;
	do 
	{
		if (waitpid(pid, &status, 0) == -1) 
		{
			trpid = 0;
			if (errno != EINTR) return -1;
		} 
		else 
		{
			trpid = 0;
			return status;
		}
	} 
	while(1);
}

void finish(char *s)
{
	char *t = s, *r =  NULL;
	while (t && (t = strstr(t, "&amp;")))
	{
		r = strdup(t+5);
		strcpy(t+1, r);
		free(r);
	}
	t = s;
	while (t && (t = strstr(t, "&quot;")))
	{
		r = strdup(t+6);
		*t = '"';
		strcpy(t+1, r);
		free(r);
	}
	t = s;
	while (t && (t = strchr(t, ':'))) *t = '-';
	s = realloc(s, strlen(s)+1);
}

void get_spinner_main()
{
	char buf[256];
	snprintf(buf, 255, "%s -q -O %s/.gspinner.spinner \"http://spinner.com/"
			"sp-lite/spinner.jhtml\"", WGET, getenv("HOME"));
	my_system(buf);
}

void get_spinner_floor(char *sessionID, int BottomSequence, int id)
{
	char buf[256];
	snprintf(buf, 255, "%s -q -O %s/.gspinner.floor \"http://spinner.com/us"
			"er.dyn;$sessionid$%s?command=setcurrentchannel&page=/s"
			"p-lite/floor.jhtml&cmd%d=dummy&version=%s&time=%d&id=%"
			"d\"", WGET, getenv("HOME"), sessionID, BottomSequence, 
			versionString, (int)time(NULL), id);
	my_system(buf);
}

void get_spinner_roof(char *sessionID)
{
	char buf[256];
	snprintf(buf, 255, "%s -q -O %s/.gspinner.roof \"http://spinner.com/sp-"
			"lite/roof.jhtml;$sessionid$%s?version=%s\"", WGET, 
			getenv("HOME"), sessionID, versionString);
	my_system(buf);
}

char *get_sessionID()
{
	FILE *gsf;
	char buf[256];
	char *sessionID = NULL;
	/* get main page */
	get_spinner_main();
	snprintf(buf, 255, "%s/.gspinner.spinner", getenv("HOME"));
	gsf = fopen(buf, "r");
	if (gsf)
	{
		/* something should be done to check bounds here */
		sessionID = malloc(24);
		memset(sessionID, 0, 24);
		while (fgets(buf, 255, gsf))
		{
			sscanf(buf, "\topencontentwindow(\"/profile/_main.jhtml"
					";$sessionid$%23c\");\r\n" , sessionID);
			if (*sessionID) return sessionID;
		}
	}
	return NULL;
}

void menu_activate(GtkObject *o, Channel *c)
{
	if (c && c != current)
	{

		if (current->id == 0) /* we are selecting a new channel */
		{
			current = c;
			pthread_cond_signal(&cond);
			return;
		} /* otherwise it's a change to another channel */
		current = c;
		kill(trpid, SIGKILL);
	}
}

void menu_add(GtkWidget *menu, char *channel, int id)
{
	int index;
	if (isdigit(*channel)) index = 1;
	else index = toupper(*channel) - 'A' + 2;
	if (menu && channel)
	{
		Channel *c;
		GList *widgets;
		GtkWidget *amenu, *amenuitem, *item;
		/* Set up Channel Struct */
		c = malloc(sizeof(Channel));
		c->name = channel;
		c->id = id;
		Channels = g_list_append(Channels, c);
		/* do widget junk */
		widgets = GTK_MENU(menu)->menu_shell.children;
		amenuitem = g_list_nth_data(widgets, index);
		amenu = GTK_MENU_ITEM(amenuitem)->submenu;
		item = gtk_menu_item_new_with_label(channel);
		gtk_menu_append(GTK_MENU(amenu), item);
		gtk_signal_connect(GTK_OBJECT(item), "activate", 
				GTK_SIGNAL_FUNC(menu_activate), c);
	}
}

void menu_prepare(GtkWidget *menu)
{
	int x;
	char letter[4];
 	GtkWidget *item, *submenu;
	/* #s */
	item = gtk_menu_item_new_with_label("#");
	submenu = gtk_menu_new();
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(item), submenu);
	gtk_menu_append(GTK_MENU(menu), item);
	/* A - Z */
	for (x=0; x<26; x++)
	{
		sprintf(letter, "%c", ('A' + x));
		item = gtk_menu_item_new_with_label(letter);
		submenu = gtk_menu_new();
		gtk_menu_item_set_submenu(GTK_MENU_ITEM(item), submenu);
		gtk_menu_append(GTK_MENU(menu), item);
	}
}

GtkWidget *get_channels(char *sessionID)
{
	int id;
	FILE *gsf;
	char buf[256];
	GtkWidget *cmenu, *none;
	snprintf(buf, 255, "%s/.gspinner.roof", getenv("HOME"));
	gsf = fopen(buf, "r");
	if (!gsf)
	{
		get_spinner_roof(sessionID);
		gsf = fopen(buf, "r");
	}
	/* set up menu for channels */
	cmenu = gtk_menu_new();
	none = gtk_menu_item_new_with_label("None");
	gtk_menu_append(GTK_MENU(cmenu), none);
	gtk_signal_connect(GTK_OBJECT(none), "activate", 
			GTK_SIGNAL_FUNC(menu_activate), cnone);
	menu_prepare(cmenu);
	/* read from file */
	if (gsf)
	{
		char name[24] = "\0";
		while (fgets(buf, 255, gsf))
		{
			if (strstr(buf, "</select>")) break;
			name[0] = '\0';
			id = 0;
			sscanf(buf, "\t\t\t\t<option value=\"%d\">%23c</option>"
					"\n" , &id, name);
			if ((id > 0) && name[0])
			{
				char *c;
				int *i = malloc(sizeof(int));
				*i = id;
				c = strrchr(name, '<');
				if (c) *c = '\0';
				c = strdup(name);
				finish(c);
				menu_add(cmenu, c, id);
			}
		}
	}
	gtk_widget_show_all(cmenu);
	return cmenu;
}

void get_raas(char **rurl, char **album, char **artist, char **song)
{
	FILE *gsf;
	int ru, al, ar, so, ch;
	char buf[256];
	ru = al = ar = so = ch = 1;
	snprintf(buf, 255, "%s/.gspinner.floor", getenv("HOME"));
	gsf = fopen(buf, "r");
	if (!gsf) return;
	*rurl = malloc(256);
	*album = malloc(128);
	*artist = malloc(128);
	*song = malloc(128);
	memset(*rurl, 0, 256);
	memset(*album, 0, 128);
	memset(*artist, 0, 128);
	memset(*song, 0, 128);
	while ((ru||al||ar||so||ch) && fgets(buf, 255, gsf))
	{
		if (ar)
		{
			sscanf(buf, " shape=\"RECT\" coords=\"10,4,71,16\" href"
					"=\"http://spinner.com/gateway/artistIn"
					"fo.jhtml?artist=%*s target=\"mainwin"
					"\" alt=\"" "%128c", *artist);
			if (**artist) 
			{
				char *c;
				ar = 0;
				c = strstr(*artist, "\">");
				if (c) *c = '\0';
				finish(*artist);
				continue;
			}
		}
		if (al)
		{
			sscanf(buf, " shape=\"RECT\" coords=\"10,24,71,36\" hre"
					"f=\"http://www.amazon.com/%*s target="
					"\"external\" alt=\"%128c", *album);
			if (**album) 
			{
				char *c;
				al = 0;
				c = strstr(*album, "\">");
				if (c) *c = '\0';
				finish(*album);
				continue;
			}
		}
		if (so)
		{
			sscanf(buf, " shape=\"RECT\" coords=\"10,44,71,56\" hre"
					"f=\"javascript:top.Registration_Window"
					"();\" alt=\"%128c", *song);
			if (**song) 
			{
				char *c;
				so = 0;
				c = strstr(*song, "\">");
				if (c) *c = '\0';
				finish(*song);
				continue;
			}
		}
		if (ru)
		{
			sscanf(buf, "\t\t\t<embed src=\"/gateway/rpm.jhtml?url_"
					"mime_type=rtsp%%3A%%2F%%2Fg2rr.spinner"
					".com%%2Fspinlinks%%2F%256c\" console="
					"\"Spinner\" autostart=\"True\" width="
					"\"20\" height=\"35\" controls=\"Volume"
					"Slider\">\r\n", *rurl);
			if (**rurl) 
			{
				char *c;
				ru = 0;
				c = strstr(*rurl, "%3F");
				if (c) *c = '\0';
				*rurl = realloc(*rurl, strlen(*rurl)+1);
				continue;
			}
		}
	}
}

Channel *get_channel()
{
	FILE *f;
	char buf[256];
	snprintf(buf, 255, "%s/.gspinner.channel", getenv("HOME"));
	if ((f = fopen(buf, "r")))
	{
		fgets(buf, 255, f);
		fclose(f);
		return (Channel *)g_list_nth_data(Channels, atoi(buf));
	}
	else return cnone;
}

void spawn_player(char *rurl)
{
	char buf[512];
	snprintf(buf, 511, "%s -n -q rtsp://g2rr.spinner.com/spinlinks/%s", 
			TRPLAYER, rurl);
	my_system(buf);
}

void spawn(GtkOptionMenu *lmenu)
{
	GtkWidget *channels;
	char *rurl, *album, *artist, *song;
	char *sessionID;
	int BottomSequence = 0;
	sessionID = get_sessionID();
	channels = get_channels(sessionID);
	gtk_option_menu_set_menu(lmenu, channels);
	current = get_channel();
	if (!current) current = cnone;
	while (1)
	{
		if (current->id == 0) pthread_cond_wait(&cond, &mutex);
		get_spinner_floor(sessionID, ++BottomSequence, current->id);
		get_raas(&rurl, &album, &artist, &song);
		/* set labels */
		gtk_label_set_text(GTK_LABEL(lartist), artist);
		gtk_label_set_text(GTK_LABEL(lalbum), album);
		gtk_label_set_text(GTK_LABEL(lsong), song);
		gtk_label_set_text(GTK_LABEL(lchannel), current->name);
		/* free memory */
		free(artist);
		free(album);
		free(song);
		spawn_player(rurl);
		free(rurl);
	}
	free(sessionID);
	pthread_exit(0);
}

void run_atexit()
{
	FILE *f;
	char buf[256];
	if (trpid) kill(trpid, SIGKILL);
	snprintf(buf, 255, "%s/.gspinner.channel", getenv("HOME"));
	if ((f = fopen(buf, "w")))
	{
		fprintf(f, "%d", g_list_index(Channels, current));
		fclose(f);
	}
}

int main(int argc, char *argv[])
{
	char buf[256];
	pthread_t thread;
	pthread_attr_t attr;
	GtkWidget *window, *table;
	gtk_init(&argc, &argv);
	/* usage */
	if (argc > 1)
	{
		int x;
		for (x = 1; x<argc; x++)
		{
			if (!strcmp(argv[x], "--version"))
			{
				printf("gspinner version 0.2 (%s)\n", 
						versionString);
			}
			if (!strcmp(argv[x], "--help"))
			{
				printf("\nWho is John Galt?\n\n");
			}
		}
		exit(0);
	}
	/* set up the default channel */
	cnone = malloc(sizeof(Channel));
	cnone->name = strdup("None");
	cnone->id = 0;
	current = cnone;
	Channels = g_list_append(NULL, cnone);
	/* atexit */
	atexit(run_atexit);
	pthread_attr_init(&attr);
	setenv("REALPLAYER_HOME", REALPLAYER_DIR, 1);

	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_default_size(GTK_WINDOW(window), 350, 100);
	gtk_window_set_policy(GTK_WINDOW(window), 0, 0, 0);
	gtk_container_set_border_width(GTK_CONTAINER(window), 5);
	gtk_signal_connect(GTK_OBJECT(window), "delete_event", gtk_main_quit, 
			NULL);

	table = gtk_table_new(5, 2, FALSE);
	gtk_container_add(GTK_CONTAINER(window), table);
	gtk_table_set_row_spacings(GTK_TABLE(table), 0);
	gtk_table_set_col_spacings(GTK_TABLE(table), 5);

	lmenu = gtk_option_menu_new();
	gtk_widget_set_usize(lmenu, 150, 0);
	/* make new labels */
	lartist = gtk_label_new("");
	lalbum = gtk_label_new("");
	lsong = gtk_label_new("");
	lchannel = gtk_label_new("");
	/* pack table */
	gtk_table_attach(GTK_TABLE(table), gtk_label_new("Artist:"),
			0, 1, 0, 1, GTK_SHRINK, GTK_SHRINK, 0, 2);
	gtk_table_attach(GTK_TABLE(table), gtk_label_new("Album:"),
			0, 1, 1, 2, GTK_SHRINK, GTK_SHRINK, 0, 2);
	gtk_table_attach(GTK_TABLE(table), gtk_label_new("Song:"),
			0, 1, 2, 3, GTK_SHRINK, GTK_SHRINK, 0, 2);
	gtk_table_attach(GTK_TABLE(table), gtk_label_new("Channel:"),
			0, 1, 3, 4, GTK_SHRINK, GTK_SHRINK, 0, 2);
	gtk_table_attach(GTK_TABLE(table), lartist, 
			1, 2, 0, 1, GTK_FILL, GTK_SHRINK, 0, 2);
	gtk_table_attach(GTK_TABLE(table), lalbum, 
			1, 2, 1, 2, GTK_FILL, GTK_SHRINK, 0, 2);
	gtk_table_attach(GTK_TABLE(table), lsong, 
			1, 2, 2, 3, GTK_FILL, GTK_SHRINK, 0, 2);
	gtk_table_attach(GTK_TABLE(table), lchannel, 
			1, 2, 3, 4, GTK_FILL, GTK_SHRINK, 0, 2);

	gtk_table_attach(GTK_TABLE(table), lmenu, 
			0, 2, 4, 5, GTK_FILL, GTK_SHRINK, 0, 2);

	snprintf(buf, 255, "%s/.gspinner.channel", getenv("HOME"));
	gtk_widget_show_all(window);
	if (pthread_create(&thread, &attr, (void *)&spawn, lmenu) < 0)
	{
		perror("pthread_create");
		exit(1);
	}
	gtk_main();
	return 0;
}
